package com.kingdee.eas.hr.project.app;

import java.math.BigDecimal;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.LineResult;
import com.kingdee.eas.framework.Result;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.eas.hr.project.IWorkHoursConfirm;
import com.kingdee.eas.hr.project.IWorkHoursReport;
import com.kingdee.eas.hr.project.ProjectManagementInfo;
import com.kingdee.eas.hr.project.WorkHoursConfirmFactory;
import com.kingdee.eas.hr.project.WorkHoursConfirmInfo;
import com.kingdee.eas.hr.project.WorkHoursReportEntryInfo;
import com.kingdee.eas.hr.project.WorkHoursReportFactory;
import com.kingdee.eas.hr.project.WorkHoursReportInfo;
import com.kingdee.eas.hr.project.dataSource;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;

public class WorkHoursFacadeControllerBean extends AbstractWorkHoursFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.hr.project.app.WorkHoursFacadeControllerBean");

    /**
     * ȷϵ
     */
    protected void _initWorkHoursConfirm(Context ctx, String number, String star, String end, int day)
    		throws BOSException, EASBizException {
    	IRowSet rs = null;
    	List<String> keyList = new ArrayList<String>();
    	IWorkHoursConfirm  biz = WorkHoursConfirmFactory.getLocalInstance(ctx); 
    	
    	WorkHoursConfirmInfo wInfo = null;
    	SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    	List<WorkHoursConfirmInfo> listInfo = null;
    	List<String> listproid = new ArrayList<String>();
    	Map<String,String> mapdate = new HashMap<String,String>();
    	Map<String,String> mapproid = new HashMap<String,String>();
    	//Ŵ map
    	Map<String,List<WorkHoursConfirmInfo>> mapInfo = new HashMap<String,List<WorkHoursConfirmInfo>>();
    	StringBuffer sb = new StringBuffer("/*dialect*/");
    	if(day <= 0) {
    		//Ĭ3
    		day = 3;
    	}
    	sb = new StringBuffer("/*dialect*/");
    	sb.append("	select  t.fid tfid,t1.fid pid,t1.fnumber,t1.fname_l2,t3.fid proid,t3.fnumber,t3.CFProjectName ,TO_CHAR(t.FPUNCHCARDTIME, 'YYYY-MM-DD') CFCLOCKTIME1 "
    			+ ",TO_CHAR(t.FPUNCHCARDTIME, 'YYYY-MM-DD HH24:MI:SS') CFCLOCKTIME,t.FPUNCHCARDPLACE FPUNCHCARDPLACE,t3en.CFCLOCKLOCATION CFCLOCKLOCATION from T_HR_ATS_PunchCardRecord t ").append(" \n");
    	sb.append("	inner join T_BD_Person t1 on t1.fid = t.FPROPOSERID ").append(" \n");
    	sb.append("	inner join CT_PRO_MemberManagement t2 on t2.CFEmployeeID = t1.fid ").append(" \n");
    	sb.append("	inner join CT_PRO_ProjectManagement t3 on t3.fid = t2.CFProjectManagemenID ").append(" \n");
    	sb.append("	left join CT_PRO_ProjectManagementEntry t3en on t3en.FPARENTID = t3.fid  ").append(" \n");
    	sb.append("	where t3.CFExpectedStartTime <FPUNCHCARDTIME and t3.CFExpectedEndTime >= FPUNCHCARDTIME ").append(" \n");
    	sb.append("	and t.fid not in (select FSOURCEBILLID from CT_PRO_WorkHoursConfirm  where FSOURCEBILLID is not null ) ").append(" \n");
    	//ʱ
    	if(star != null) {
    		sb.append("	and t.FPUNCHCARDTIME  >= TO_CHAR("+star+", 'YYYY-MM-DD HH24:MI:SS')").append(" \n");
    	}else if(end != null) {
    		sb.append("	and t.FPUNCHCARDTIME  <= TO_CHAR("+end+", 'YYYY-MM-DD HH24:MI:SS')").append(" \n");
    	}else {
    		sb.append("	and t.FPUNCHCARDTIME >= sysdate -"+day).append(" \n");
    	}
    	if(number !=null && number.length() > 0) {
    		sb.append("	and t1.fnumber in (").append(number).append(") \n");
    	}
    	sb.append("	order by t1.fid, t.FPUNCHCARDTIME desc ").append(" \n");//
    	//ȡ
    	rs = DbUtil.executeQuery(ctx, sb.toString());
    	try {
			while (rs.next()) {
				String pid = rs.getString("pid");
				String tfid = rs.getString("tfid");
				String proid = rs.getString("proid");
				String CFCLOCKLOCATION = rs.getString("CFCLOCKLOCATION"); //Ŀλ
				String FPUNCHCARDPLACE = rs.getString("FPUNCHCARDPLACE"); //λô
				String CFCLOCKTIME = rs.getString("CFCLOCKTIME"); //ʱ ʱ
				String CFCLOCKTIME1 = rs.getString("CFCLOCKTIME1"); //--------ǰ
				String key = pid+CFCLOCKTIME1;//Աid+Ϊ һ Ψһ
				//ͬһ첻ڶĿ½б
				if(!listproid.contains(key) && mapproid.containsKey(key) && mapproid.get(key).equals(proid)) {
					listproid.add(key);
				}
				//ȥ-ʱƥ-
				if(mapdate.containsKey(key) && mapproid.get(key).equals(CFCLOCKTIME)) {
					continue;
				}
				if(mapInfo.containsKey(key)) {
					listInfo = mapInfo.get(key);
				}else {
					listInfo = new ArrayList<WorkHoursConfirmInfo>();
					keyList.add(key);
					mapproid.put(key, proid);
					mapdate.put(key, CFCLOCKTIME);
				}
				wInfo = getWConfirmInfo(ctx,pid, proid,CFCLOCKLOCATION,FPUNCHCARDPLACE,simpleDateFormat.parse(CFCLOCKTIME),tfid);
				listInfo.add(wInfo);
				mapInfo.put(key, listInfo);
			}
		} catch (SQLException | ParseException e) {
			e.printStackTrace();
		}
    	//д
    	CoreBaseCollection addSubColl = new CoreBaseCollection();
    	CoreBaseCollection addAudColl = new CoreBaseCollection();
    	//ĿҲͬһĿ
    	List<String> notList = new ArrayList<String>();
    	if(listproid.size() > 0) {
        	for (int i = 0; i < listproid.size(); i++) {
        		String key = listproid.get(i);
        		listInfo = mapInfo.get(key);
        		String oldprojid = null;
        		boolean isoneprojid = true;
        		for (int j = 0; j < listInfo.size(); j++) {
        			wInfo = listInfo.get(j);
        			if(j == 0) {
        				if(wInfo.getProject().getId() != null) {
        					oldprojid = wInfo.getProject().getId().toString();
        				}else {
        					oldprojid = "0";
        				}
        			}else {
        				//ͬһĿ
            			if(!oldprojid.equals(wInfo.getProject().getId().toString()) || wInfo.getProject().getId() == null) {
            				isoneprojid = false;
            				break;
            			}
        			}
    			}
        		//ͬһĿ
        		if(!isoneprojid) {
        			for (int j = 0; j < listInfo.size(); j++) {
            			wInfo = listInfo.get(j);
            			wInfo.setProject(null); //Ŀ
            			wInfo.setBillState(HRBillStateEnum.SAVED);//ݴ
            			addSubColl.add(wInfo);
        			}
        			notList.add(key);
        		}
    		}
    	}
    	//ʣݴ
    	if (keyList.size() > 0){
    		for (int i = 0; i < keyList.size(); i++) {
    			String key = keyList.get(i);
    			if(notList.contains(key)) {
    				continue;
    			}
        		listInfo = mapInfo.get(key);
        		for (int j = 0; j < listInfo.size(); j++) {
        			wInfo = listInfo.get(j);
        			//ֱЧ
        			if(wInfo.getBillState().compareTo(HRBillStateEnum.AUDITED) == 0) {
        				addAudColl.add(wInfo);
        			}else {
        				//ƥ䲻ϵ
        				addSubColl.add(wInfo);
        			}
    			}
			}
    	}
    	//ύ
    	if(addSubColl.size() > 0) {
    		biz.submit(addSubColl);
    	}
    	if(addAudColl.size() > 0) {
    		//洦-ͨ
        	Result re = biz.addnew(addAudColl);
        	LineResult lr = null;
        	if(re != null && re.size() > 0){
        		for (int i = 0; i < re.size(); i++) {
        			lr = re.getLineResult(i);
        			biz.setAudited(BOSUuid.read(lr.getPk().toString())); //-ͨ
    			}
        	}
    	}
    }
    
    /**
     * Ϊʱȷϵ
     * @param pid
     * @param proid
     * @param p1
     * @param p2
     * @param clockTime
     * @return
     */
    private WorkHoursConfirmInfo getWConfirmInfo(Context ctx,String pid,String proid,String p1,String p2,Date clockTime,String FSOURCEBILLID) {
    	WorkHoursConfirmInfo wInfo = new WorkHoursConfirmInfo();
    	PersonInfo pinfo = new PersonInfo();pinfo.setId(BOSUuid.read(pid)); //Ա
    	
    	PersonCollection personCollection = null;
		try {
			personCollection = PersonFactory.getLocalInstance(ctx).getPersonCollection(" select * where id = '"+pid+"'");
		} catch (BOSException e) {
			e.printStackTrace();
		}
		if(personCollection != null && personCollection.size()>0){
			pinfo = personCollection.get(0);
		}
		
		ProjectManagementInfo proinfo = new ProjectManagementInfo();proinfo.setId(BOSUuid.read(proid)); //Ŀ
		wInfo.setEmployee(pinfo);
		wInfo.setProject(proinfo); //Ŀ
		wInfo.setClockDate(clockTime); //
		wInfo.setSourceBillId(FSOURCEBILLID);//Դid
		wInfo.setHrOrgUnit(pinfo.getHrOrgUnit());
		wInfo.setCU(pinfo.getCU());
		Timestamp t = new Timestamp(clockTime.getTime());
		wInfo.setClockTime(t); //--------------------------------------------------------------------------------------------------------------
		//λ clockLocation 
		if(p1.equals(p2)) {
			wInfo.setClockLocation(p2);
			wInfo.setBillState(HRBillStateEnum.AUDITED);//ͨ
		}else {
			wInfo.setProject(null); //Ŀ
			wInfo.setBillState(HRBillStateEnum.SAVED);//ݴ
		}
		return wInfo;
    }
    
    /**
     * ʱ
     */
    protected void _updateWorkHoursReport(Context ctx, String number, String star, String end, int day,String type)
    		throws BOSException, EASBizException {
    	//ȡʱȷϵɹʱ
    	String CFCLOCKTIME = null; //-ʱ
		String CFCLOCKDATE = null; //
		String CFPROJECTID = null; //Ŀid
		String CFEMPLOYEEID = null; //Աid
		String CFCLOCKLOCATION = null; //λ
		String fid = null; //fid
    	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    	SimpleDateFormat sdfs = new SimpleDateFormat("HH:mm:ss");
    	IWorkHoursReport biz = WorkHoursReportFactory.getLocalInstance(ctx);
    	CoreBaseCollection coll = new CoreBaseCollection();
    	WorkHoursReportInfo info = null;
    	List<String> listDate = new ArrayList<String>(); //һж
    	Map<String,List<Map<String,String>>> dateMap = null;
    	List<Map<String,String>> listMap = null;
    	Map<String,List<String>> mapListPersonid = new HashMap<String,List<String>>(); //ÿж
    	List<String> personidList = null;
    	Map<String,String> map = null;
    	Map<String,Map<String,List<Map<String,String>>>> mapRs = new HashMap<String,Map<String,List<Map<String,String>>>>();
    	if(day <= 0) {
    		//Ĭ3
    		day = 3;
    	}
    	StringBuffer sb = new StringBuffer("/*dialect*/");
    	sb.append("	select fid fid,CFPROJECTID CFPROJECTID,CFEMPLOYEEID CFEMPLOYEEID"
    			+ " ,TO_CHAR(CFCLOCKDATE, 'YYYY-MM-DD') CFCLOCKDATE"
    			+ " ,TO_CHAR(CFCLOCKTIME, 'YYYY-MM-DD HH24:MI:SS') CFCLOCKTIME "
    			+ " FROM CT_PRO_WorkHoursConfirm where FBILLSTATE ='3' "
    			+ " and CFPROJECTID is not null ").append(" \n");
    	//ʱ
    	if(star != null) {
    		sb.append("	and CFCLOCKDATE  >= TO_CHAR("+star+", 'YYYY-MM-DD HH24:MI:SS')").append(" \n");
    	}else if(end != null) {
    		sb.append("	and CFCLOCKDATE  <= TO_CHAR("+end+", 'YYYY-MM-DD HH24:MI:SS')").append(" \n");
    	}else {
    		sb.append("	and CFCLOCKDATE >= sysdate -"+day).append(" \n");
    	}
    	if(number !=null && number.length() > 0) {
    		sb.append("	and CFEMPLOYEEID in (select fid from (").append(number).append(")) \n");
    	}
    	sb.append("	 order by  CFEMPLOYEEID,CFCLOCKTIME asc").append(" \n");//
    	//ȡ-ͨ
    	IRowSet rs = DbUtil.executeQuery(ctx, sb.toString());
    	System.out.println("sb"+sb);
		try {
			while (rs.next()) {
				CFCLOCKTIME = rs.getString("CFCLOCKTIME"); //-ʱ
				CFCLOCKDATE = rs.getString("CFCLOCKDATE"); //
				CFPROJECTID = rs.getString("CFPROJECTID"); //Ŀid
				CFEMPLOYEEID = rs.getString("CFEMPLOYEEID"); //Աid
				CFCLOCKLOCATION = "";//rs.getString("CFCLOCKLOCATION"); //λ
				fid = rs.getString("fid"); //fid
				map = new HashMap<String,String>();
				map.put("CFCLOCKTIME", CFCLOCKTIME);
				map.put("CFCLOCKDATE", CFCLOCKDATE);
				map.put("CFPROJECTID", CFPROJECTID);
				map.put("CFEMPLOYEEID", CFEMPLOYEEID);
				map.put("fid", fid);
				if(!listDate.contains(CFCLOCKDATE)){
					listDate.add(CFCLOCKDATE);
					dateMap = new HashMap<String,List<Map<String,String>>>();
					personidList = new ArrayList<String>();
				}else {
					dateMap = mapRs.get(CFCLOCKDATE);
					personidList = mapListPersonid.get(CFCLOCKDATE);
				}
				//ظԱ
				if(!personidList.contains(CFEMPLOYEEID)) {
					personidList.add(CFEMPLOYEEID);
					listMap = new ArrayList<Map<String,String>>();
				}else {
					listMap = dateMap.get(CFEMPLOYEEID);
				}
				listMap.add(map);
				
				dateMap.put(CFEMPLOYEEID,listMap);
				mapListPersonid.put(CFCLOCKDATE, personidList); 
				mapRs.put(CFCLOCKDATE, dateMap);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		List<String> delist = new ArrayList<String>();
    	//һһĴ
		for (int i = 0; i < listDate.size(); i++) {
			CFCLOCKDATE = listDate.get(i);
			dateMap = mapRs.get(CFCLOCKDATE);
			personidList = mapListPersonid.get(CFCLOCKDATE);
			for (int j = 0; j < personidList.size(); j++) {
				CFEMPLOYEEID = personidList.get(j);//Աid
				listMap = dateMap.get(CFEMPLOYEEID); //жٴ
				String oldCFPROJECTID = null; //ɵĿ
				String oldCFCLOCKTIME = null;   //ɵĴʱ
				String oldfid = null;   //ɵfid
				String deleteWhere = " CFEMPLOYEEID='"+CFEMPLOYEEID+"' and to_char(CFDATA,'YYYY-MM-DD') = '"+CFCLOCKDATE+"'";
				for (int j2 = 0; j2 < listMap.size(); j2++) {
					map = listMap.get(j2);
					CFCLOCKTIME = map.get("CFCLOCKTIME"); //-ʱ
					CFPROJECTID = map.get("CFPROJECTID"); //Ŀid
					CFEMPLOYEEID = map.get("CFEMPLOYEEID"); //Աid
					CFCLOCKLOCATION = map.get("CFEMPLOYEEID"); //λ
					fid = map.get("fid"); //fid
					//һμ¼
					if(j2 == 0){
						oldCFPROJECTID = CFPROJECTID;
						oldCFCLOCKTIME = CFCLOCKTIME;
						oldfid = fid;
					}
					//һεĲһ
					if(!oldCFPROJECTID.equals(CFPROJECTID)) {
						map = listMap.get(j2-1);
						CFCLOCKTIME = map.get("CFCLOCKTIME"); //-ʱ
						CFPROJECTID = map.get("CFPROJECTID"); //Ŀid
						CFEMPLOYEEID = map.get("CFEMPLOYEEID"); //Աid
						CFCLOCKLOCATION = map.get("CFEMPLOYEEID"); //λ
						fid = map.get("fid"); //fid
						//ȡһεһݽбȽϼ
						//ʱСʱ
						try {
							Date oldDate = sdf.parse(oldCFCLOCKTIME);
							Date date = sdf.parse(CFCLOCKTIME);
					        long diffInMillies = date.getTime() - oldDate.getTime();
					        // תΪСʱ
					        long diffInHours = diffInMillies / (60 * 60 * 1000);
					        BigDecimal hours = new BigDecimal(diffInHours);
					        //װ
					        info = initInfo(ctx,CFEMPLOYEEID, oldCFPROJECTID, date, sdf.format(sdf.parse(CFCLOCKTIME)), null, hours,oldfid+","+fid);
					        if(!delist.contains(deleteWhere)) {
					        	delist.add(deleteWhere);
					        }
					        coll.add(info);
						} catch (ParseException ee) {
							ee.printStackTrace();
						}
						//ǰ¿ʼ
						map = listMap.get(j2);
						CFCLOCKTIME = map.get("CFCLOCKTIME"); //-ʱ
						CFPROJECTID = map.get("CFPROJECTID"); //Ŀid
						CFEMPLOYEEID = map.get("CFEMPLOYEEID"); //Աid
						CFCLOCKLOCATION = map.get("CFEMPLOYEEID"); //λ
						fid = map.get("fid"); //fid
						oldCFPROJECTID = CFPROJECTID;
						oldCFCLOCKTIME = CFCLOCKTIME;
						oldfid = fid;
					}
					
					//һμ¼
					if(j2 == listMap.size()-1){
						if(oldCFPROJECTID.equals(CFPROJECTID) && !oldCFCLOCKTIME.equals(CFCLOCKTIME)) { //Ŀͬʱͬ
							try {
								Date oldDate = sdf.parse(oldCFCLOCKTIME);
								Date date = sdf.parse(CFCLOCKTIME);
						        long diffInMillies = date.getTime() - oldDate.getTime();
						        // תΪСʱ
						        long diffInHours = diffInMillies / (60 * 60 * 1000);
						        BigDecimal hours = new BigDecimal(diffInHours);
						        //װ
						        info = initInfo(ctx,CFEMPLOYEEID, oldCFPROJECTID, date, sdf.format(sdf.parse(CFCLOCKTIME)), null, hours,oldfid+","+fid);
						        if(!delist.contains(deleteWhere)) {
						        	delist.add(deleteWhere);
						        }
						        coll.add(info);
							} catch (ParseException ee) {
								ee.printStackTrace();
							}
						}
					}
				}
			}
		}
		//ɾ
		if(type.equals("update") && delist.size() > 0) {
			//ɾ
			for (int i = 0; i < delist.size(); i++) {
				DbUtil.execute(ctx, " delete from CT_PRO_WorkHoursReport where CFDATASOURCE = 'workHoursCal' and  FBILLSTATE = '3' "
						+ "and CFFILLINGSTARTDATE = CFFILLINGENDDATE and fid in(select FParentID from CT_PRO_WorkHoursReportentry where "+delist.get(i)+") ");
				DbUtil.execute(ctx, " delete from CT_PRO_WorkHoursReportentry where "+delist.get(i)+" ");
			}
    	}
		//洦-ͨ
		System.out.println("coll"+coll.toString());
    	if(coll.size() > 0) {
    		for (int i = 0; i < coll.size(); i++) {
    			info = (WorkHoursReportInfo) coll.get(i);
    			IObjectPK pk = biz.addnew(info);
    			biz.setAudited(BOSUuid.read(pk.toString())); //-ͨ
			}
    	}
    }
    
    /**
     * װʱ
     * @param pid
     * @param proid
     * @param data
     * @param ClockTime
     * @param ClockLocation
     * @param hours
     * @return
     */
    private WorkHoursReportInfo initInfo(Context ctx,String pid,String proid,Date data,String ClockTime
    		,String ClockLocation,BigDecimal hours,String ids) {
    	WorkHoursReportInfo info = new WorkHoursReportInfo();
    	WorkHoursReportEntryInfo einfo = new WorkHoursReportEntryInfo();
    	PersonInfo pinfo = new PersonInfo();pinfo.setId(BOSUuid.read(pid)); //Ա
    	PersonCollection personCollection = null;
		try {
			personCollection = PersonFactory.getLocalInstance(ctx).getPersonCollection(" select * where id = '"+pid+"'");
		} catch (BOSException e) {
			e.printStackTrace();
		}
		if(personCollection != null && personCollection.size()>0){
			pinfo = personCollection.get(0);
		}
		ProjectManagementInfo proinfo = new ProjectManagementInfo();
		proinfo.setId(BOSUuid.read(proid)); //Ŀ
		info.setHrOrgUnit(pinfo.getHrOrgUnit());
		info.setCU(pinfo.getCU());
		info.setDataSource(dataSource.workHoursCal);
    	info.setAffiliatedProject(proinfo);
    	info.setBillState(HRBillStateEnum.AUDITED); //ͨ
    	info.setFillingStartDate(data); //Ĭϵ
    	info.setFillingEndDate(data); //Ĭϵ
    	info.setSourceBillId(ids);
    	einfo.setEmployee(pinfo);
//    	einfo.setClockLocation("ʱ");
    	einfo.setClockTime(ClockTime); //ʱ
    	einfo.setData(data); //
    	einfo.setWorkingHours(hours); //ʱ
    	info.getEntrys().add(einfo);
    	return info;
    }
    
}